#include "estbench.h"
#include <suifkernel/command_line_parsing.h>

#include <suifkernel/suif_env.h>
#include <suifkernel/module_subsystem.h>
#include <suifkernel/module.h>
#include <suifpasses/passes.h>
#include <basicnodes/basic.h>
#include <suifnodes/suif.h>
#include <esuifnodes/esuif.h>
#include <iostream>

class EstBenchPass : public Pass {
public:
  EstBenchPass(SuifEnv *env, const LString &name = "estbench")
    : Pass(env, name) {}

  ~EstBenchPass() {}

  Module *clone() const { return (Module*)this; }
  void initialize() { Pass::initialize(); }

  /// Does the work
  void do_file_set_block(FileSetBlock*);
  
};

void EstBenchPass::do_file_set_block(FileSetBlock *fsb)
{
  EstBench eb(get_suif_env());

  eb.fileSetBlock(fsb);

  std::cout << eb.result << endl;
}

extern "C" void init_estbench(SuifEnv *env)
{
  env->require_module("basicnodes");
  env->require_module("suifnodes");
  env->require_module("esuifnodes");

  init_basicnodes(env);
  init_suifnodes(env);
  init_esuifnodes(env);

  ModuleSubSystem *ms = env->get_module_subsystem();

  ms->register_module(new EstBenchPass(env, "estbench"));
}
